#include "exErrors.h"

#include <stdint.h>
#include <stdbool.h>
#include <string.h>

#if defined(_WIN32) && !defined(_CVI_)
#define INLINE __inline
#else
#define INLINE inline
#endif

#ifdef __cplusplus
extern "C" {
#endif

 //!
 //! @file
 //!
 //! Switch constants.
 //!

#ifndef _SwitchConstants_H
#define _SwitchConstants_H

 //
 // IVI class-compliant constants
 //
enum VTEXSwitchPathCapabilityEnum
{
  VTEXSwitchPathAvailable = 100,
  VTEXSwitchPathExists = 101,
  VTEXSwitchPathUnsupported = 102,
  VTEXSwitchPathRsrcInUse = 103,
  VTEXSwitchPathSourceConflict = 104,
  VTEXSwitchPathChannelNotAvailable = 105,
  VTEXSwitchPathChannelOneUnknown = 106,
  VTEXSwitchPathChannelTwoUnknown = 107,
  VTEXSwitchPathCannotConnectToItself = 108,
  VTEXSwitchPathWireModeMismatch = 109
};

enum VTEXSwitchAdvancedOutputEnum
{
  VTEXSwitchAdvancedOutputNone = 0,
  VTEXSwitchAdvancedOutputExternal = 2,
  VTEXSwitchAdvancedOutputLXISync = 1200,
  VTEXSwitchAdvancedOutputBPL0 = 1000,
  VTEXSwitchAdvancedOutputBPL1 = 1001,
  VTEXSwitchAdvancedOutputBPL2 = 1002,
  VTEXSwitchAdvancedOutputBPL3 = 1003,
  VTEXSwitchAdvancedOutputBPL4 = 1004,
  VTEXSwitchAdvancedOutputBPL5 = 1005,
  VTEXSwitchAdvancedOutputBPL6 = 1006,
  VTEXSwitchAdvancedOutputBPL7 = 1007
};

enum VTEXSwitchScanModeEnum
{
  VTEXSwitchScanModeBreakBeforeMake = 300,
  VTEXSwitchScanModeBreakAfterMake = 301,
  VTEXSwitchScanModeNone = 302
};

enum VTEXSwitchTriggerInputEnum
{
  VTEXSwitchTriggerInputImmediate = 1,
  VTEXSwitchTriggerInputExternal = 2,
  VTEXSwitchTriggerInputSwTrigFunc = 3,
  VTEXSwitchTriggerInputLXISync = 1200,
  VTEXSwitchTriggerInputBPL0 = 1000,
  VTEXSwitchTriggerInputBPL1 = 1001,
  VTEXSwitchTriggerInputBPL2 = 1002,
  VTEXSwitchTriggerInputBPL3 = 1003,
  VTEXSwitchTriggerInputBPL4 = 1004,
  VTEXSwitchTriggerInputBPL5 = 1005,
  VTEXSwitchTriggerInputBPL6 = 1006,
  VTEXSwitchTriggerInputBPL7 = 1007
};

 //
 // Instrument-specific constants
 //
enum VTEXSwitchExternalConnectionEnum
{
  VTEXSwitchExternalConnectionConnect = 500,
  VTEXSwitchExternalConnectionDisconnect = 501
};

enum VTEXSwitchRelayStateEnum
{
  VTEXSwitchRelayStateOpen = 600,
  VTEXSwitchRelayStateClosed = 601,
  VTEXSwitchRelayStateCommandedOpen = 602,
  VTEXSwitchRelayStateCommandedClosed = 603,
  VTEXSwitchRelayStateIndeterminate = 604
};
#endif /* ! _SwitchConstants_H */

#ifdef  __cplusplus
}
#endif

