//This class, which is only for internal use, should be subclassed by each driver that needs readfifo logic so that we implement this logic in a common way.
#ifndef FIFO_READER
#define FIFO_READER

#include "utilsContainer.h"
class FifoReader
{
  public:
    //We need the UtilsContainer for the EXPManager it contains.
    FifoReader(UtilsContainer* utils, int32_t max_timeout, VTEXResult timeout_error_code);
    virtual ~FifoReader() {};

    //This is the function the user-class calls which implements all the timeout/max reading logic
    VTEXResult FifoRead(int32_t sampleCount, int32_t MaxTimeMilliseconds); 

  protected:
    //This is the function that the subclass implements which calls the EXP logic
    //The result should be retrieved out of class-local variables in the subclass
    virtual VTEXResult GetData(int32_t sampleCount, int32_t MaxTimeMilliseconds, int32_t* numReturned)=0;
    virtual VTEXResult GetFifoCount(int32_t* fifoCount) = 0;
    UtilsContainer* m_utils;
    VTEXResult timeout_error;
    int32_t m_timeout;
    exTime new_exp_timeout;
};

#endif

