/******************************************************************************
 *
 *  .----------------------.	
 *  |==     ==  ======  == |	$Author: benf $
 *  | ==   ==   ======  == |	$Revision: 
 *  |  == ==      ==    == |	$Date: 2009-12-02 08:23:36 -0800 (Wed, 02 Dec 2009) $ 
 *  |   ===       ==    == |	$HeadURL: http://10.1.0.10/svn/nextgen/branches/Version_3_12_0/software/Instrument_drivers/libVTEX/common/impInherentUtility.cpp $
 *  |    =        ==    == |	
 *  `----------------------'
 *
 * Copyright 2006 VXI Technology Inc. as an unpublished work.
 * All rights reserved. The information contained herein is confidential
 * property of VXI Technology, Inc. Use, copy, transfer or disclosure
 * of such information is prohibited except by express written agreement
 * with VXI Technology, Inc.
 *
 * PURPOSE:
 *   IVI inherent capabilities Utility interface
 *
 ******************************************************************************/


/*******************
 * System header
 *******************/


/*******************
 * Library header
 *******************/


/*******************
 * Local header
 *******************/
#include "utilsContainer.h"
#include "functionLogging.h"
#include "iviOptions.h"
#include "errorManager.h"
#include "impInherent.h"
#include "state.h"

/***********************
 * Forward Declarations
 ***********************/


ImpInherentCapabilityUtility::ImpInherentCapabilityUtility(UtilsContainer* utils, State* state)
{
    m_utils = utils;
    m_state = state;
    return;
}   

ImpInherentCapabilityUtility::~ImpInherentCapabilityUtility()
{
    return;
}

VTEXResult ImpInherentCapabilityUtility::Disable()
{
    m_utils->log->Log(__FUNCTION__, 0);
	VTEXResult status = IVI_SUCCESS;
	// do nothing.  Don't return NOT_SUPPORTED.
 //   VTEXResult status = m_utils->errorManager->queueError(IVI_E_METHOD_NOT_SUPPORTED, __FUNCTION__);
    return m_utils->errorManager->ReportError(status);
}

VTEXResult ImpInherentCapabilityUtility::ErrorQuery(int32_t *ErrorCode, VTEXString& ErrorMessage)
{
    m_utils->log->Log(__FUNCTION__, 0);

    VTEXResult status = m_state->initialized();
    VTEXResult tempErrorCode = IVI_SUCCESS;

    if( (status >= IVI_SUCCESS) && (NULL == ErrorCode) )
    {
        status = m_utils->errorManager->queueError(IVI_E_NULL_POINTER, __FUNCTION__, "ErrorCode");
    }
    else if(status >= IVI_SUCCESS)
    {
#if defined(WIN32) && defined(DLL_EXPORTS)
		std::string _ErrorMessage;
		status = m_utils->errorManager->deQueue(&tempErrorCode, _ErrorMessage);
		_bstr_t bstr = _ErrorMessage.c_str();
		ErrorMessage = bstr.copy();
#else
        status = m_utils->errorManager->deQueue(&tempErrorCode, ErrorMessage);
#endif
        *ErrorCode = (int32_t)tempErrorCode;
    }

    return m_utils->errorManager->ReportError(status);
}

VTEXResult ImpInherentCapabilityUtility::Reset()
{
    m_utils->log->Log(__FUNCTION__, 0);
	VTEXResult status = IVI_SUCCESS;

	m_utils->iviOptions->ResetIVIAttributes();

    return m_utils->errorManager->ReportError(status);
}

VTEXResult ImpInherentCapabilityUtility::ResetWithDefaults()
{
    m_utils->log->Log(__FUNCTION__, 0);
	VTEXResult status = IVI_SUCCESS;

	m_utils->iviOptions->ResetIVIAttributes();

    return m_utils->errorManager->ReportError(status);
}


VTEXResult ImpInherentCapabilityUtility::SelfTest(int32_t *TestResult, VTEXString& TestMessage)
{
    m_utils->log->Log(__FUNCTION__, 0);
	VTEXResult status = IVI_SUCCESS;  // Don't return NOT_SUPPORTED Error.

	if(NULL == TestResult )
            status = m_utils->errorManager->queueError(IVI_E_NULL_POINTER, __FUNCTION__, "TestResult");
	else  *TestResult = 0;

    return m_utils->errorManager->ReportError(status);
}

VTEXResult ImpInherentCapabilityUtility::LockObject()
{
  m_utils->log->Log(__FUNCTION__, 0);
  m_utils->errorManager->queueError(IVI_E_METHOD_NOT_SUPPORTED, __FUNCTION__);
  return m_utils->errorManager->ReportError(IVI_E_METHOD_NOT_SUPPORTED);
}

VTEXResult ImpInherentCapabilityUtility::UnlockObject()
{
  m_utils->log->Log(__FUNCTION__, 0);
  m_utils->errorManager->queueError(IVI_E_METHOD_NOT_SUPPORTED, __FUNCTION__);
  return m_utils->errorManager->ReportError(IVI_E_METHOD_NOT_SUPPORTED);
}
